﻿Public Class CFrmLoadGra
    ' 画像を読み込む時の状態フラグ
    Const FILE_GET_LOCAL As Integer = &H1
    Const FILE_GET_HTTP_HIDE As Integer = &H2
    Const FILE_GET_HTTP_SHOW As Integer = &H6
    ' LGCの準備が良いか悪いかのフラグ
    Dim g_bValid As Boolean

    ' 参照ボタン押下時のハンドラ
    Private Sub btnFileSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFileSelect.Click
        Dim objOFD As New OpenFileDialog
        Dim strFilter As String

        strFilter = LGCtrl.GetFileFilter()
        strFilter = strFilter.Substring(0, strFilter.Length - 1)
        objOFD.Filter = strFilter

        '       objOFD.FilterIndex = 1
        objOFD.Title = "画像ファイル選択"
        objOFD.RestoreDirectory = False
        objOFD.CheckFileExists = True
        objOFD.CheckPathExists = True

        If objOFD.ShowDialog() = DialogResult.OK Then
            txtPath.Text = objOFD.FileName

            Try
                ' LoadGraCtrlで画像を開く
                If LGCtrl.LoadPicture(txtPath.Text) Then
                    SetPicSize()
                End If
            Catch except As Exception
                MsgBox(except.Message, MsgBoxStyle.Critical)
                SetPicSize()
            Finally
                objOFD = Nothing
            End Try
        End If
    End Sub

    ' URLから画像を表示
    Private Sub btnURLSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnURLSelect.Click
        Try
            ' LoadGraCtrlで画像を開く
            If LGCtrl.LoadPicture(txtPath.Text, FILE_GET_HTTP_SHOW) Then
                SetPicSize()
            End If
        Catch except As Exception
            MsgBox(except.Message, MsgBoxStyle.Critical)
            SetPicSize()
        End Try
    End Sub

    ' 閉じるボタン押下時のハンドラ
    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        LGCtrl.ReleaseLGC()

        Dispose()
    End Sub

    ' ファイル名表示ボタン押下時のハンドラ
    Private Sub btnShowFileName_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnShowFileName.Click
        If LGCtrl.GetShowFileName Then
            LGCtrl.SetShowFileName(False)
        Else
            LGCtrl.SetShowFileName(True)
        End If
        SetPicSize()
    End Sub
    ' バージョンボタン押下時のハンドラ
    Private Sub btnShowVer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnShowVer.Click
        LGCtrl.ShowAboutBox()
    End Sub

    ' 画像サイズ表示
    Private Sub SetPicSize()
        Dim DefPicSize As LoadGraLib.tsPIC_SIZE
        Dim ShowPicSize As LoadGraLib.tsPIC_SIZE
        Dim MaxMoveX As LoadGraLib.tsMAX_MOVE
        Dim MaxMoveY As LoadGraLib.tsMAX_MOVE

        ' 元の画像サイズ
        DefPicSize = LGCtrl.GetDefaultPicSize()
        ' 表示中の画像サイズ
        ShowPicSize = LGCtrl.GetShowPicSize()
        lblData.Text = "元の画像サイズ=" & DefPicSize.nWidth & "×" & DefPicSize.nHeight & vbCrLf & "表示中の画像サイズ=" & ShowPicSize.nWidth & "×" & ShowPicSize.nHeight

        ' 拡大時(LGCの表示領域より大きい時)のみ画像移動が使えるのでこのタイミングで最小/最大移動量を取得
        MaxMoveX = LGCtrl.GetMaxMoveOriginX()
        nudOrignPlusX.Minimum = MaxMoveX.nMin
        nudOrignPlusX.Maximum = MaxMoveX.nMax

        MaxMoveY = LGCtrl.GetMaxMoveOriginY()
        nudOrignPlusY.Minimum = MaxMoveY.nMin
        nudOrignPlusY.Maximum = MaxMoveY.nMax
    End Sub

    ' 枠表示/非表示
    Private Sub btnShowMargin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnShowMargin.Click
        If LGCtrl.GetViewMargin() Then
            LGCtrl.SetViewMargin(False)
        Else
            LGCtrl.SetViewMargin(True)
        End If
        SetPicSize()
    End Sub


    ' ロードされているSPIの数表示
    Private Sub btnSPICount_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSPICount.Click
        Dim nSPICount As Integer

        nSPICount = LGCtrl.GetLoadSPICount()
        MsgBox(CType(nSPICount, String))
    End Sub

    ' ロードされているSPIの情報表示
    Private Sub btnSPIInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSPIInfo.Click
        Dim varSPIInfoArray As Object
        Dim strInfo As String = ""
        Dim nLoopCount As Long

        varSPIInfoArray = LGCtrl.GetSPIInfo
        nLoopCount = 0
        ' 1個のSPI情報あたり3個の情報が帰ってくるため3倍（0=PlugInVer情報、1=PlugIn文字列、2=対応拡張子）
        Do While (nLoopCount < LGCtrl.GetLoadSPICount * 3)
            strInfo = strInfo & "[" & varSPIInfoArray(nLoopCount) & "][" & varSPIInfoArray(nLoopCount + 1) & "][" & varSPIInfoArray(nLoopCount + 2) & "]" & vbCrLf
            nLoopCount = nLoopCount + 3
        Loop

        MsgBox(strInfo)
    End Sub

    ' 画面消去
    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        LGCtrl.ClearPicture()
        txtPath.Clear()
        SetPicSize()
    End Sub

    ' 画像表示角度設定
    Private Sub nupAngle_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles nupAngle.ValueChanged
        Dim nAngle As Long

        nAngle = nupAngle.Value
        LGCtrl.SetAngle(nAngle)
        SetPicSize()
    End Sub

    ' SPIを読み込むディレクトリを設定
    Private Sub btnBrowseSPI_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBrowseSPI.Click
        Dim FBDlg As New FolderBrowserDialog

        FBDlg.SelectedPath = txtSPIDir.Text

        If FBDlg.ShowDialog = DialogResult.OK Then
            txtSPIDir.Text = FBDlg.SelectedPath()
            LGCtrl.SetSPIDir(txtSPIDir.Text)
        End If
    End Sub

    ' フォームの準備
    Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
        Dim strPath As String

        ' SPIのあるディレクトリを取得
        strPath = LGCtrl.GetSPIDir()
        txtSPIDir.Text = strPath

        ' LGC準備完了だと思う
        g_bValid = True
    End Sub

    '' LoadGraコントロールの画像読み込み状況イベントハンドラ
    'Private Sub LGCtrl_LoadPicNotify(ByVal sender As Object, ByVal e As LoadGraLib._ILoadGraCtrlEvents) Handles LGCtrl.LoadPicNotify
    '    ' 画像読み込み中の再読み込み防止
    '    If e.nState = 0 Then
    '        btnFileSelect.Enabled = False
    '        btnURLSelect.Enabled = False
    '    Else
    '        btnFileSelect.Enabled = True
    '        btnURLSelect.Enabled = True
    '    End If
    'End Sub

    Private Sub btnVerStr_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnVerStr.Click
        MsgBox(LGCtrl.GetVer)
    End Sub

    ' 拡大/縮小率設定
    Private Sub nupMagnifyPer_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles nupMagnifyPer.ValueChanged
        Dim fMagnifyPer As Single

        fMagnifyPer = nupMagnifyPer.Value
        ' LGCの準備が終わってないとエラーになるのでフラグを使う
        If g_bValid Then
            LGCtrl.SetPicMagnifyPer(fMagnifyPer)
            SetPicSize()
        End If
    End Sub

    ' 拡大時の画像表示位置変更X座標設定
    Private Sub nudOrignPlusX_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles nudOrignPlusX.ValueChanged
        Dim nOrigin As Integer

        nOrigin = nudOrignPlusX.Value
        If g_bValid Then
            LGCtrl.SetMoveOriginX(nOrigin)
        End If
    End Sub

    ' 拡大時の画像表示位置変更Y座標設定
    Private Sub nudOrignPlusY_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles nudOrignPlusY.ValueChanged
        Dim nOrigin As Integer

        nOrigin = nudOrignPlusY.Value
        If g_bValid Then
            LGCtrl.SetMoveOriginY(nOrigin)
        End If
    End Sub

    Private Sub chkRotateMode_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles chkRotateMode.Click
        Dim bRotateMode As Boolean

        bRotateMode = LGCtrl.GetRotateMode()
        If bRotateMode Then
            LGCtrl.SetRotateMode(False)
        Else
            LGCtrl.SetRotateMode(True)
        End If
    End Sub
End Class

